part of '../flutterx_live_data.dart';

class ToggleLiveData extends MutableLiveData<bool> {
  ToggleLiveData({bool super.value = false});

  void toggle() {
    _data = !_data;
    invalidate();
  }
}

class StorageToggleLiveData extends ToggleLiveData with StorageMixin<bool> {
  @override
  final String key;

  @override
  final bool defaultValue;

  @override
  final Map<String, String> storage;

  @override
  StringEncode<bool> get encode => (value) => value.toString();

  StorageToggleLiveData({
    required this.key,
    this.defaultValue = false,
    required this.storage,
  }) : super(value: StorageMixin.resolve(key, defaultValue, storage, (source) => 'true' == source));
}
